#!/usr/bin/ruby -Ks
#
require '/opt/yklook/swing'
require '/opt/yklook/swingborder'
require '/opt/yklook/swingcanvas'
require '/opt/yklook/swinggraph'

class BusinessGraph < YKLookMain

	FieldPosition = [ "îP", "îQ", "îR", "îS",
					"îP", "îQ", "îR", "îS" ]

	def yki_size()
		return [640, 320]
	end

	def yki_title()
		return 'rWlXpOt`'
	end

	def yki_make_display()

		valIni = [ "10",  "30",  "20", "40", "100", "150", "120", "80" ]

		@colors = []
		@colors << YKLookColor.new( [255, 204, 255] )   # pink
		@colors << YKLookColor.new( [255, 204, 204] )   # usu beni
		@colors << YKLookColor.new( [204, 255, 204] )   # usu beni
		@colors << YKLookColor.new( [204, 204, 204] )   # grey
		yk_var( '@colors' )

		strutH10 = YKLookBoxFiller.new( 10, 0 )
		strutV10 = YKLookBoxFiller.new( 0, 10 )

		black = YKLookColor.new( 'black' )

		graBox  = YKLookPanelBox.new( 'H' )
		valPan  = YKLookPanelGridBag.new()
		ctrBox  = YKLookPanelBox.new( 'H' )
		baseBox = YKLookPanelBox.new( 'V' )
		cvCircle = YKLookCanvas.new( 200, 200 ).yk_set_tag( "cvCircle" )
		cvBar    = YKLookCanvas.new( 200, 200 ).yk_set_tag( "cvBar"    )
		cvLine   = YKLookCanvas.new( 200, 200 ).yk_set_tag( "cvLine"   )

		cvCircle.yk_set_tooltip( "Sʈȉ͂܂Ƃ߂ĕ\" )
		cvBar   .yk_set_tooltip( "iƉi̒lɑΉ" )
		cvLine  .yk_set_tooltip( "iԁAi" )
		cvCircle.yk_set_border( ['line', black] )
		cvBar   .yk_set_border( ['line', black] )
		cvLine  .yk_set_border( ['line', black] )

		gbc1 = { 'gridwidth' =>  1  }
		gbcr = { 'gridwidth' => nil }

		valIni.each_with_index() do |val,idx|
			fld = YKLookTextField.new( 5, val ).yk_set_tag( "val", idx )
			valPan.yk_add( fld, (((idx+1) % 4) == 0) ? gbcr : gbc1 )
		end

		btnUpdate = YKLookButton.new( "\XV" )

		graBox.yk_add( cvCircle )
		graBox.yk_add( strutH10 )
		graBox.yk_add( cvBar )
		graBox.yk_add( strutH10 )
		graBox.yk_add( cvLine )
		ctrBox.yk_add( valPan )
		ctrBox.yk_add( strutH10 )
		ctrBox.yk_add( btnUpdate )
		baseBox.yk_add( graBox )
		baseBox.yk_add( strutV10 )
		baseBox.yk_add( ctrBox )
		yk_add( baseBox )

		fn_actionPerformed( nil )

		btnUpdate.yk_set_listener( :fn_actionPerformed )
	end

	def fn_actionPerformed( prmEvent )
		begin
			val = []
			for idx in 0...8 do
				val << fn_value( idx )
			end
			fn_circle( val )
			fn_bar(    val )
			fn_line(   val )
			msg = nil
		rescue => ex
			msg = ex.message()
			if not msg.include?( "̓G[F" )
				raise
			end
		end
		if msg
			yk_show_dialog_message( nil, msg )
		end
	end

	def fn_value( prm_idx )
		val = yk_look( "val", prm_idx ).yk_text()
		if val =~ /\A-?[0-9]+\.?[0-9]*\z/
			val = val.to_f()
			if val < 0
				raise "̓G[F̒l͎wł܂(#{FieldPosition[prm_idx]})"
			end
			return val
		end
		raise "̓G[Flw肵Ă(#{FieldPosition[prm_idx]})"
	end

	def fn_circle( prm_val )
		# wrkVal = prm_val.sort().reverse()
		# vals = wrkVal[0..2]
		# remain = 0
		# wrkVal[3..-1].each() do |v|
		#	remain += v
		# end
		# vals << remain

		name = ["P", "Q", "R", "S",
				"P", "Q", "R", "S"]
		cvCir = yk_look('cvCircle')
		cvCir.yk_clear()
		cvCir.yk_draw_pie( 20, 20, 160, prm_val, name, @colors, 5, 10, 3 )
	end

	def fn_bar( prm_val )
		grBar = yk_look( 'grBar' )
		if grBar
			grBar.yk_clear_item_data()
		else
			grBar = YKLookGraphBar.new( 200, 200 ).yk_set_tag( 'grBar' )
		end
		grBar.yk_set_margin( 10, 20, 20, 10 )
		grBar.yk_set_item_color( 'black', [ 'red', 'blue' ] )
		grBar.yk_set_item_attr( 'R', 'R' )
		grBar.yk_set_scale_auto()

		# f[^̐ݒ 1
		#
		# grBar.yk_add_item_data( "-1", [ prm_val[0], prm_val[4] ] )
		# grBar.yk_add_item_data( "-2", [ prm_val[1], prm_val[5] ] )
		# grBar.yk_add_item_data( "-3", [ prm_val[2], prm_val[6] ] )
		# grBar.yk_add_item_data( "-4", [ prm_val[3], prm_val[7] ] )

		# f[^̐ݒ 2
		#
		# for number in [1..4]
		#	index = number - 1
		#	name  = "-" + number.to_s()
		#	value = [ prm_val[index], prm_val[index+4] ]
		#	grBar.yk_add_item_data( name, value )
		# end

		# f[^̐ݒ 3
		#
		grBar.yk_set_item_data( ["-1","-2","-3","-4"],
								[ prm_val[0..3], prm_val[4..7] ] )

		cvBar = yk_look('cvBar')
		cvBar.yk_clear()
		cvBar.yk_draw_graph( grBar, 0, 0 )
	end

	def fn_line( prm_val )
		grLine = yk_look( 'grLine' )
		if grLine
			grLine.yk_clear_item_data()
		else
			grLine = YKLookGraphLine.new( 200, 200 ).yk_set_tag( 'grLine' )
		end
		grLine.yk_set_margin( 10, 20, 20, 10 )
		grLine.yk_set_item_color( 'black', [ 'red', 'blue' ] )
		grLine.yk_set_scale_auto()

		grLine.yk_set_item_data( ["1s","2s","3s","4s"],
								 [ prm_val[0..3], prm_val[4..7] ] )

		cvLine = yk_look('cvLine')
		cvLine.yk_clear()
		cvLine.yk_draw_graph( grLine, 0, 0 )
	end

	##def yki_laf_is_system()
	##	return false
	##end
	# def yki_fr_need_pack()
	#	return true
	# end
	# def yki_ht_farpath()
	#	return [ '/tools' , nil ]
	# end
end

YKLookMain.yk_mainloop( BusinessGraph.new() )

#
# end of program
